import logging
from functools import wraps

from flask import request, json, Response

log = logging.getLogger('flask-backend')


def token_required(f):
    @wraps(f)
    def decorated_function(*args, **kwargs):
        token = None
        if 'token' in request.args:
            token = request.args['token']
        if 'token' in request.view_args:
            token = request.view_args['token']
        if token is not None:
            with open("/barix/apps/icpgw/users_backup.json") as file:
                mydict = json.load(file)
                payload = None
                userValid = False
                statusCode = None
                for key in mydict:
                    if mydict[key]["secret"] == token:
                        userValid = True
                if userValid:
                    return f(*args, **kwargs)
                else:
                    log.info("User with no permission: {}".format(token))
                    return Response(status=401)
        else:
            log.info("User with no permission: {}".format(token))
            return Response(status=401)
    return decorated_function
