import logging
from logging.handlers import RotatingFileHandler

"""
Init logger
"""


def configLogger(name, log_file_path, log_max_size, log_backup_count):
    log = logging.getLogger(name)
    log.setLevel(logging.DEBUG)
    rotHandler = RotatingFileHandler(log_file_path, maxBytes=log_max_size, backupCount=log_backup_count)
    format1 = logging.Formatter('%(asctime)s  %(levelname)s  %(filename)s:%(lineno)s  %(message)s')
    rotHandler.setFormatter(format1)
    log.addHandler(rotHandler)
