import logging
from flask import Blueprint, Response

from barix.web.auth import login_required
from barix.web.reset_to_defaults import resetToDefaults

log = logging.getLogger('flask-backend')

bp = Blueprint('defaults_API', __name__)

@bp.route('/api/rest/v1/defaults', methods=['POST'])
@login_required
def handleResetToDefaultsRequest():
    try:
        resetToDefaults()
    except Exception as e:
        log.error(e)
        return Response(status=500)
    else:
        return Response(status=200)