import os, sys
import constants
import shared_variables
import audioop
import time

from threading import Thread
from queue import Queue
from utils import get_logger, check_wav_file_format
from typing import Union, Tuple

from paging_master import PagingMaster

#shared_variables.paging_controller._device_idle()
#shared_variables.paging_controller._check_user()
#shared_variables.paging_controller.is_operation_allowed()

class PagingController:
    def __init__(self):
        """
        Description
        
        Args:
        
        Returns:
        """

        self.logger = get_logger("PagingController")
        self.logger.info("PagingController initialize...")

    def _device_idle(self):
        if shared_variables.paging_state or shared_variables.playfile_state:
            # logger.warning("Device is currently being used!")
            return False
        return True
    
    def _check_user(self, secret):
        # Add timer to the user connection in case of bad messages.
        # timer = Timer("_check_user")
        # timer.start()
        if shared_variables.active_user is None:
            #shared_variables.active_user = shared_variables.users.get_user_from_token(secret)
            # timer.stop()
            #return True if shared_variables.active_user is not None else False
            return True if shared_variables.users.get_user_from_token(secret) is not None else False
        elif shared_variables.users.secret(shared_variables.active_user) != secret:
            # timer.stop()
            return False
        # timer.stop()
        return True

    def is_operation_allowed(self, uuid, operation) -> bool:
        msg = f"{operation} is allowed for UUID: {uuid}"
        if shared_variables.active_user_uuid is None:
            shared_variables.active_user_uuid = uuid

        elif uuid != shared_variables.active_user_uuid:
            # TODO: When same user token but different groups are selected, the operations should be allowed
            # Different UUID trying to page from the same user token is not allowed
            self.logger.warning(f"{operation} NOT allowed for UUID: {uuid}")
            return False
        self.logger.info(msg)
        return True
    
        
    