import os, sys
import constants
import shared_variables
import audioop
import time

from threading import Thread
from queue import Queue
from utils import get_logger, check_wav_file_format
from typing import Union, Tuple

# list functions:
#
# start_playing_file
# _play_message
#
# start_paging_message
# stop_paging_message
# _encode_send_audio_queue
# local_playback_start
# _read_from_local_playback_queue
#
# local_playback_stop
#
# encode_send_audio
#
# extract_token_and_audio
# 
# start_playing_file
# stop_playing_file
# 


logger = get_logger("paging")


def start_playing_file(message):
    
    #shared_variables.downloading_recorded_message = constants.NO
    #shared_variables.first_fast_packets = 0
    #shared_variables.kill_playfile_thread = constants.NO
    
    paging_priority = int(shared_variables.config["paging_priority"])
#
    #if shared_variables.last_message_type == 8:
    #    # This is the correct order of the messages when playfile should be STARTED
    #    if message["groups"] == "":
    #        logger.warning("No groups selected")
    #    else:
    #        clients = shared_variables.groups.get_clients(message["groups"])
    #        shared_variables.last_client = clients
    #        if shared_variables.playfile_group_thread is None:
    #            shared_variables.playfile_group_thread = Thread(
    #                target=shared_variables.pmaster.send_page_group_request,
    #                daemon=True, name="PlayFileGroup",
    #                kwargs={"clients": clients, "priority": paging_priority},
    #            )
    #            shared_variables.playfile_group_thread.start()
    #        else:
    #            logger.error("Thread already running. Needs to be closed first. Returning")
    #            return
    #            
    #        logger.debug("playfile_group_thread started")
#
    #    shared_variables.first_fast_packets = 0
#
    #else:
    #    # In case the last message was not ended correctly
    #    logger.warning("Last message not ended properly. Ending it first!")
        
    if shared_variables.last_client:
        if shared_variables.playfile_group_thread is not None:
            logger.warning("$$$$$$ REMOVING EXISTING THREAD playfile_playing_thread. Not proper ending")
            shared_variables.playfile_group_thread.join(timeout=0.5)
            shared_variables.playfile_group_thread = None
        if shared_variables.playfile_playing_thread is not None:
            logger.warning("$$$$$$ REMOVING EXISTING THREAD playfile_playing_thread. Not proper ending")
            shared_variables.playfile_playing_thread.join(timeout=0.5)
            shared_variables.playfile_playing_thread = None

        shared_variables.pmaster.send_end_group_request(shared_variables.last_client)
    
    if message["groups"] == "":
        shared_variables.last_client = None
        logger.warning("No group selected")
    else:
        clients = shared_variables.groups.get_clients(message["groups"])
        shared_variables.last_client = clients
        shared_variables.playfile_group_thread = Thread(
            target=shared_variables.pmaster.send_page_group_request,
            daemon=True, name="PlayFileGroup",
            kwargs={"clients": clients, "priority": paging_priority},
        )
        shared_variables.playfile_group_thread.start()
        logger.info("playfile_group_thread started.")

    shared_variables.playfile_state = constants.IDLE



    #logger.info(f"rtp_enabled {shared_variables.config['rtp_enabled']}")
    #if shared_variables.config["rtp_enabled"] == True:
    #    shared_variables.rtp_processor.start_stream(
    #        shared_variables.config["rtp_ip"],
    #        shared_variables.config["rtp_port"],
    #        shared_variables.config["rtp_format"]
    #    )


    
    shared_variables.last_message_type = 3

    logger.info(f"START playing file {message['file_to_open']} to {message['groups']}")

    try:
        #if "button_ID" in message.keys():
        #    args = [message["file_ID"], message["button_ID"]]
        #else:
        #    logger.warning("Button ID not in request. Using filename...")
        #    args = [message["file_ID"], None]
        args = [message["file_to_open"]]

        shared_variables.playfile_playing_thread = Thread(
            target=_play_message, daemon=True, name="PlayFilePlaying",
            # kwargs={"file_id": message["file_ID"]},
            args=args
        )
        shared_variables.playfile_playing_thread.start()
        logger.info("playfile_playing_thread started")
    except TypeError:
        logger.warning(f"Oops: {sys.exc_info()[0]} occurred")
    except OSError as error:
        logger.warning("While in _play_message() the following error occurred:")
        logger.warning(error)

    shared_variables.first_fast_packets = 0


def stop_playing_file(message):

    #shared_variables.rtp_processor.stop_stream()

    shared_variables.pregong_function = None
    shared_variables.pregong_playing = False


    #if message["groups"] == "":
    #    logger.warning("No groups selected")
    #else:
    #    logger.debug(f"stop_playing_file - groups: {message['groups']}")
    clients = shared_variables.groups.get_clients(message["groups"])
    shared_variables.pmaster.send_end_group_request(clients)
    shared_variables.kill_playfile_thread = constants.YES

    if shared_variables.playfile_group_thread is not None:  # Make sure no zombie process is left
        logger.warning("$$$$$$ REMOVING EXISTING THREAD playfile_group_thread")
        shared_variables.playfile_group_thread.join(timeout=0.5)
        shared_variables.playfile_group_thread = None
    if shared_variables.playfile_playing_thread is not None:  # Make sure no zombie process is left
        logger.warning("$$$$$$ REMOVING EXISTING THREAD playfile_playing_thread")
        shared_variables.playfile_playing_thread.join(timeout=0.5)
        shared_variables.playfile_playing_thread = None

    shared_variables.last_client = None
    shared_variables.last_message_type = 8
    shared_variables.active_user = None
    shared_variables.active_user_uuid = None
    shared_variables.playfile_state = constants.IDLE

    # logger.warning("Running threads left")
    # for thread in enumerate():
    #     logger.warning(thread.name)



#def _play_message(file_id: str = "", button_id: Union[str, None] = None):
def _play_message(file_to_open):
    """
        Used to send the locally stored audio files
        Args:
            file_id: ID (filename) of the file to be played
            button_id: ID of the button pressed
        Returns:
    """
    audio_file = None

    if os.path.isfile(file_to_open):
        shared_variables.kill_playfile_thread = constants.NO
        logger.debug(f"play audio file {file_to_open}")
    else:
        shared_variables.kill_playfile_thread = constants.YES
        logger.debug(f"unknown audio file {file_to_open}")


    if shared_variables.kill_playfile_thread is not constants.YES:

        #file_to_open = os.path.join(constants.PROCESSED_FILES_PATH, file_id)
        try:
            with open(file_to_open, 'rb') as file_in_mem:
                # TODO: This needs to be properly detected for each file, based on the header data
                audio_file = file_in_mem.read()[600:]  # skip the riff & wav header and metadata

            # convert the data to 16-bit signed
            audio_file = audioop.ulaw2lin(audio_file, 2)
        except Exception as ex:
            logger.warning("Unable to read the given %s into bytes: %s", file_to_open, ex)
            shared_variables.kill_playfile_thread = constants.YES
        #del file_to_open  # Variable not needed anymore

        # Local playback
        try:
            shared_variables.local_playback_process = Thread(
                target=shared_variables.write_to_local_playback,
                args=(audio_file,),
                name="AlsaPlayer"
            )
            shared_variables.local_playback_process.daemon = True
            shared_variables.local_playback_process.start()
            # logger.warning("New local_playback_process started as: %s!", local_playback_process.name)
        except TypeError:
            logger.warning(f"Oops: {sys.exc_info()[0]} occurred")
        except OSError as error:
            logger.warning("While in shared_variables.write_to_local_playback the following error occurred:")
            logger.warning("Check audio device: %s", shared_variables.config["audio_device"]["playback"])
            logger.warning(error)
    else:
        logger.info("Unable to proceed with execution. shared_variables.kill_playfile_thread is set to: %s !!!",
                    shared_variables.kill_playfile_thread)

    # sent to groups
    if (shared_variables.pmaster.state == 130) and \
            audio_file is not None and \
            shared_variables.kill_playfile_thread is not constants.YES:  # MSG 130, send custom command

        data_block_size = 1280
        # delay = float("{0:.4f}".format(data_block_size / 2 / 8 / 1000))
        delay = 0.079

        if shared_variables.config["sample_rate"] == 8000:
            data_block_size = 1280
            # data_block_size = 320
            delay = float("{0:.4f}".format(data_block_size / 2 / 8 / 1000)) - 0.001
            # delay = 0.080
        elif shared_variables.config["sample_rate"] == 24000:
            data_block_size = 1280
            delay = float("{0:.4f}".format(data_block_size / 2 / shared_variables.config["sample_rate"])) - 0.001
            delay = 0.0261  # TODO: This needs to be properly calculated
            # delay = 0.040
        else:
            logger.warning("Sample rate not supported")

        leftover = len(audio_file) % data_block_size
        count = 0

        if shared_variables.config["audio_format"] == "ulaw":
            shared_variables.playfile_state = constants.BUSY
            # shared_variables.audio_files.set_active_audio_file(file_id)
            logger.info("Using %s audio format", shared_variables.config["audio_format"])
            logger.info(f"Sending {data_block_size/2} byte packages with {delay}s delay")

            for i in range(len(audio_file) // data_block_size):
                # Needed in order to be able to properly kill the thread prematurely
                if shared_variables.kill_playfile_thread is not constants.YES:
                    if shared_variables.first_fast_packets < constants.PACKETS_NUMBER:
                        # time.sleep(0.002)
                        time.sleep(delay)  # data_block_size//2//8 ms
                        shared_variables.first_fast_packets += 1
                    else:
                        time.sleep(delay)  # data_block_size//2//8 ms

                    shared_variables.pmaster.audio_socket.sendto(
                        audioop.lin2ulaw(audio_file[i * data_block_size: (i + 1) * data_block_size], 2),
                        (
                            shared_variables.pmaster.page_to_address,
                            shared_variables.pmaster.page_to_port,
                        ),
                    )
                    count = count + data_block_size
                else:
                    logger.warning("File playing stopped prematurely.")
                    break

            if leftover != 0:
                shared_variables.pmaster.audio_socket.sendto(
                    audioop.lin2ulaw(audio_file[len(audio_file) - leftover:], 2),
                    (
                        shared_variables.pmaster.page_to_address,
                        shared_variables.pmaster.page_to_port,
                    ),
                )
                count = count + leftover
            logger.info(f"Sent this many bytes: {count/2}, out of {len(audio_file)/2}")

        elif shared_variables.config["audio_format"] == "alaw":
            shared_variables.playfile_state = constants.BUSY
            # shared_variables.audio_files.set_active_audio_file(file_id)
            logger.info("Using %s audio format", shared_variables.config["audio_format"])

            for i in range(len(audio_file) // data_block_size):
                # Needed in order to be able to properly stop playing prematurely
                if shared_variables.kill_playfile_thread is not constants.YES:
                    shared_variables.pmaster.audio_socket.sendto(
                        audioop.lin2alaw(audio_file[i * data_block_size: (i + 1) * data_block_size], 2),
                        (
                            shared_variables.pmaster.page_to_address,
                            shared_variables.pmaster.page_to_port,
                        ),
                    )
                    count = count + data_block_size
                    if shared_variables.first_fast_packets < constants.PACKETS_NUMBER:
                        # time.sleep(0.002)
                        time.sleep(delay)  # data_block_size//2//8 ms
                        shared_variables.first_fast_packets = shared_variables.first_fast_packets + 1
                    else:
                        time.sleep(delay)  # data_block_size//2//8 ms
                else:
                    logger.warning("File playing stopped prematurely.")
                    break

            if leftover != 0:
                shared_variables.pmaster.audio_socket.sendto(
                    audioop.lin2alaw(audio_file[len(audio_file) - leftover:], 2),
                    (
                        shared_variables.pmaster.page_to_address,
                        shared_variables.pmaster.page_to_port,
                    ),
                )
                count = count + leftover
            logger.info(f"Sent this many bytes: {count/2}, out of {len(audio_file)/2}")

        else:
            logger.error(
                f"Audio format not recognized : {shared_variables.config['audio_format']}"
            )
            return

        # Kill the local playback process. Important for the case when the user stops the playback earlier
        if shared_variables.local_playback_process is not None:
            shared_variables.kill_alsa_player()
            shared_variables.local_playback_process.join(timeout=0.5)
            shared_variables.local_playback_process = None

        shared_variables.playfile_state = constants.IDLE
        shared_variables.audio_files.set_active_audio_file(None)
        logger.info(f"Successfully finished playing file {file_to_open}")


        
        message = {"groups":shared_variables.last_client}
        #stop_playing_file(message)
        clients = shared_variables.groups.get_clients(message["groups"])
        shared_variables.pmaster.send_end_group_request(clients)
        shared_variables.kill_playfile_thread = constants.YES

    else:
        logger.error("The request could not be processed because of conflict in the current state of the resource")
        return





def local_playback_stop():
        # logger.warning("Trying to stop the local playback")
        # Kill the local playback process. Important for the case when the user stops the playback earlier
        shared_variables.end_operation = True
        if shared_variables.local_playback_queue_process is not None:
            logger.debug("local_playback_queue_process not None")
            #shared_variables.local_playback_queue_process.join(timeout=0.5)
            shared_variables.local_playback_queue_process = None
            shared_variables.local_playback_msg_queue = None
            logger.debug("local_playback_queue_process ended!!!")
        else:
            logger.warning("shared_variables.local_playback_queue_process already None")

        shared_variables.kill_alsa_player()


def local_playback_start():
    """
        This function is used for the local playback, when live paging is performed.
    Returns:

    """

    logger.debug("local_playback_start")


    if shared_variables.local_playback_msg_queue is None:
        try:
            shared_variables.end_operation = False
            shared_variables.local_playback_msg_queue = Queue(100)  # constants.Q_SIZE
            # logger.info(f"Created local playback queue")
        except Exception as e:
            logger.warning(f"Following occurred: {e}")
    else:
        logger.error("Could not start a new Q. shared_variables.local_playback_msg_queue already exists")

    # Local playback
    if shared_variables.local_playback_queue_process is None:
        try:
            shared_variables.local_playback_queue_process = Thread(
                target=_read_from_local_playback_queue,
                kwargs={"m_queue": shared_variables.local_playback_msg_queue},
                daemon=True,
            )
            shared_variables.local_playback_queue_process.setName("LocalPlayback")
            # logger.info(f"New local playback thread created")
        except TypeError:
            logger.warning(f"Oops: {sys.exc_info()[0]} occurred")
        except OSError as error:
            logger.warning("Check audio device: %s", shared_variables.config["audio_device"]["playback"])
            logger.warning(error)
    else:
        logger.error("Could not start a new local playback thread. Thread already exists")



def _read_from_local_playback_queue(m_queue: Queue):
    """
        Only reading from the queue. Started as a separate thread during live paging
    Args:
        m_queue: The message queue which is written to inside _page_audio
    """

    logger.info(f"Starting reading from local playback queue")
    block_size = 912

    while shared_variables.paging_controller.paging_state and not shared_variables.end_operation:
        try:
            q_size = m_queue.qsize()
            if q_size != 0:
                data_to_play = m_queue.get(block=False)
                length = len(data_to_play)
                leftover = length % block_size
                count = 0

                for i in range(length // block_size):
                    audio_to_send = data_to_play[i * block_size: (i + 1) * block_size]
                    shared_variables.write_to_local_playback(data=audio_to_send, live_paging=True)
                    count = count + block_size

                if leftover != 0:
                    shared_variables.write_to_local_playback(data=data_to_play[length - leftover:],
                                                                live_paging=True)
                    count = count + leftover
                # logger.info(f"Sent this many bytes: {count/2}, out of {length/2}")

                m_queue.task_done()
        except Exception as e:
            logger.warning(f"Following occurred: {e}")
        time.sleep(0.001)

    logger.info("Finished reading from local playback queue")
    # m_queue.task_done()


def start_paging_message(message):    
    path = message["path"]
    logger.debug("start_paging_message")

    shared_variables.watchDog_live_paging.config(10, stop_paging_message, message.copy())
    shared_variables.watchDog_live_paging.start()

    if shared_variables.last_message_type != 8:
        logger.warning("Last message not ended properly. Ending it first!")

        local_playback_stop()
        logger.warning("Current send_page_group_thread value: %s",
                    shared_variables.send_page_group_thread)

        if shared_variables.last_client:
            if shared_variables.send_page_group_thread is not None:
                shared_variables.send_page_group_thread.join(timeout=0.5)
                shared_variables.send_page_group_thread = None
            shared_variables.pmaster.send_end_group_request(shared_variables.last_client)

    #logger.info(f"rtp_enabled {shared_variables.config['rtp_enabled']}")
    #if shared_variables.config["rtp_enabled"] == True:
    #    shared_variables.rtp_processor.start_stream(
    #        shared_variables.config["rtp_ip"],
    #        shared_variables.config["rtp_port"],
    #        shared_variables.config["rtp_format"]
    #    )
    
    paging_priority = int(shared_variables.config["paging_priority"])

    data_block_size = 320
    delay = 0.002
    # logger.info("Sample rate: %s", shared_variables.config["sample_rate"])
    if shared_variables.config["sample_rate"] == 8000:
        data_block_size = 912
        delay = float("{0:.4f}".format(data_block_size / 2 / shared_variables.config["sample_rate"]))
        # delay = 0.02
    elif shared_variables.config["sample_rate"] == 24000:
        data_block_size = 964
        delay = float("{0:.4f}".format(data_block_size / 2 / shared_variables.config["sample_rate"]))
        # delay = 0.02
    else:
        logger.warning("Sample rate not supported")



    clients = shared_variables.groups.get_clients(message["groups"])
    shared_variables.last_client = clients
    shared_variables.send_page_group_thread = Thread(
        target=shared_variables.pmaster.send_page_group_request,
        kwargs={"clients": clients, "priority": paging_priority},
    )
    shared_variables.send_page_group_thread.daemon = True
    shared_variables.send_page_group_thread.setName("PageGroup")
    shared_variables.send_page_group_thread.start()


    if path == "/paging":
        shared_variables.paging_controller.paging_state = constants.BUSY
        # TODO: Not tested
        shared_variables.paging_message_q = Queue(constants.Q_SIZE)
        shared_variables.paging_message_q_thread = Thread(
            target=_encode_send_audio_queue,
            kwargs={"m_queue": shared_variables.paging_message_q,
                    "audio_format": shared_variables.config["audio_format"],
                    "block_size": data_block_size,
                    "delay": delay},
            daemon=True,
        )
        shared_variables.paging_message_q_thread.setName("PageMsgQ")
        logger.info("paging_message_q started")


    # Init the message queue for local playback and prep the process
    local_playback_start()

    shared_variables.last_message_type = 3
    shared_variables.first_fast_packets = 0

def stop_paging_message(message):
    path = message["path"]
    #shared_variables.rtp_processor.stop_stream()

    shared_variables.last_client = None
    shared_variables.last_message_type = 8
    shared_variables.active_user = None
    shared_variables.active_user_uuid = None
    shared_variables.downloading_recorded_message = constants.YES

    shared_variables.watchDog_live_paging.stop()
    shared_variables.pregong_function = None
    shared_variables.pregong_playing = False


    if path == "/paging":
        
        # Wait until the queue is empty 
        #if shared_variables.paging_message_q is not None:
        #    while shared_variables.paging_message_q.empty() is False:
        #        logger.warning(f"Waiting for queue to be emptied: {shared_variables.paging_message_q.qsize()}")
        #        time.sleep(1)
#
        #if shared_variables.local_playback_msg_queue is not None:
        #    while shared_variables.local_playback_msg_queue.empty() is False:
        #        logger.warning(f"Waiting for queue to be emptied: {shared_variables.local_playback_msg_queue.qsize()}")
        #        time.sleep(1)


        local_playback_stop()

        # 16 depends on the settings from the front end.
        logger.info(f"Total received data: {shared_variables.paging_message_q_buff_msg*16}kb")

        shared_variables.paging_controller.paging_state = constants.IDLE
        shared_variables.paging_message_q_buff_msg = 0

        # First join the queue
        if shared_variables.paging_message_q is not None:
            #if shared_variables.paging_message_q.is_alive():
            shared_variables.paging_message_q.join()
            shared_variables.paging_message_q = None

        # Second join the reading thread
        if shared_variables.paging_message_q_thread is not None:
            if not shared_variables.paging_message_q_thread.is_alive():
                shared_variables.paging_message_q_thread.start()
            #res = shared_variables.paging_message_q_thread.join(timeout=0.5)
            shared_variables.paging_message_q_thread = None

    if message["groups"] == "":
        logger.warning("No groups selected")
    else:
        if shared_variables.send_page_group_thread is not None:
            shared_variables.send_page_group_thread.join(timeout=0.5)
            shared_variables.send_page_group_thread = None
        clients = shared_variables.groups.get_clients(message["groups"])
        shared_variables.pmaster.send_end_group_request(clients)
    
    shared_variables.last_client = None
    shared_variables.last_message_type = 8
    shared_variables.active_user = None
    shared_variables.active_user_uuid = None
    shared_variables.downloading_recorded_message = constants.YES

    #if path == "/recording":
    shared_variables.record_service.exit()
    

def _encode_send_audio_queue(m_queue, audio_format="", block_size=1920, delay=0.001):
    """
    Only use this function for live paging
    Reads PCM 16 audio buffers from a message queue, encodes them to either uLaw or aLaw and sends them over
    through the socket to the selected clients.
    Args:
        m_queue: Message queue holding binary IO audio buffers
        audio_format: uLaw or aLaw allowed
        block_size: Packet size to be encoded and sent at a time
        delay: Delay in [s] between the different packets

    Returns: Void
    """

    audio_bin_buff = 0

    # TODO: Debug audio issues after long paging
    # from pathlib import Path
    # live_paging_file = "/tmp/live_paging_test"
    # store_test_file = True
    #
    # file = Path(live_paging_file)
    # file.touch(exist_ok=True)

    # Run until the paging_state is changed to IDLE
    while shared_variables.paging_controller.paging_state:
        if m_queue is not None:
            try:
                # starttime = timeit.default_timer()
                audio_bin_buff = m_queue.get(block=True)
                # endtime = timeit.default_timer()
                # logger.warning(f"Time to read from queue: {(endtime-starttime)*1000}ms")
            except Exception as e:
                logger.warning(f"Error occurred while trying to read from queue: {e}")
            q_size = m_queue.qsize()

            count = 0
            length = len(audio_bin_buff)
            leftover = length % block_size

            logger.info(f"Block size: {block_size}, delay: {delay}, q_len: {q_size}")
            # logger.info(f"Value of first fast packets variable: {shared_variables.first_fast_packets}")

            # logger.info(f"Len of data: {length}")

            if audio_format == "ulaw":
                # starttime = timeit.default_timer()
                for i in range(length // block_size):
                    audio_to_send = audio_bin_buff[i * block_size: (i + 1) * block_size]

                    # elapsed_time = time.perf_counter() - self._start_time  // i
                    mulaw_encoded = audioop.lin2ulaw(audio_to_send, 2)
                    shared_variables.pmaster.audio_socket.sendto(
                        mulaw_encoded,
                        (shared_variables.pmaster.page_to_address, shared_variables.pmaster.page_to_port,),
                    )

                    count = count + block_size

                    # Burst the first PACKETS_NUMBER packages to accumulate a buffer to read from,
                    # then go with equal intervals
                    if shared_variables.first_fast_packets < constants.PACKETS_NUMBER:
                        time.sleep(0.004)
                        shared_variables.first_fast_packets = shared_variables.first_fast_packets + 1
                    else:
                        time.sleep(delay)

                # If there is data left over from the buffer, send it at the end without delay
                if leftover != 0:
                    shared_variables.pmaster.audio_socket.sendto(
                        audioop.lin2ulaw(audio_bin_buff[length - leftover:], 2),
                        (shared_variables.pmaster.page_to_address, shared_variables.pmaster.page_to_port,),
                    )
                    count = count + leftover
                # logger.info(f"Sent this many bytes: {count/2}, out of {length/2}")
                # endtime = timeit.default_timer()
                # logger.warning(f"Time needed to send to clients: {(endtime-starttime)*1000}ms")
            elif audio_format == "alaw":
                for i in range(length // block_size):
                    # elapsed_time = time.perf_counter() - self._start_time  // i
                    shared_variables.pmaster.audio_socket.sendto(
                        audioop.lin2alaw(audio_bin_buff[i * block_size: (i + 1) * block_size], 2),
                        (
                            shared_variables.pmaster.page_to_address,
                            shared_variables.pmaster.page_to_port,
                        ),
                    )
                    count = count + block_size

                    # Burst the first PACKETS_NUMBER packages to accumulate a buffer to read from,
                    # then go with equal intervals
                    if shared_variables.first_fast_packets < constants.PACKETS_NUMBER:
                        time.sleep(0.004)
                        shared_variables.first_fast_packets = shared_variables.first_fast_packets + 1
                    else:
                        time.sleep(delay)

                # If there is data left over from the buffer, send it at the end without delay
                if leftover != 0:
                    shared_variables.pmaster.audio_socket.sendto(
                        audioop.lin2alaw(audio_bin_buff[length - leftover:], 2),
                        (
                            shared_variables.pmaster.page_to_address,
                            shared_variables.pmaster.page_to_port,
                        ),
                    )
                    count = count + leftover
                # logger.info(f"Sent this many bytes: {count / 2}, out of {length / 2}")
            else:
                msg = f"Audio format not recognized : {audio_format}"
                logger.error(msg)
                return
                
            logger.debug(f"Paging state: {shared_variables.paging_controller.paging_state}")
            m_queue.task_done()
    logger.debug("Finished paging thread")



def encode_send_audio(audio_bin_buff, audio_format="", block_size=1920, delay=0.001):
    """
    Takes the PCM 16 audio buffer, encodes it to either uLaw or aLaw and sends it over through the socket
    to the selected clients
    Args:
        audio_bin_buff: Binary IO audio buffers
        audio_format: uLaw or aLaw allowed
        block_size: Packet size to be encoded and sent at a time
        delay: Delay in [s] between the different packets

    Returns: Void
    """

    count = 0
    length = len(audio_bin_buff)
    leftover = length % block_size

    logger.info(f"Using block size: {block_size}, and delay: {delay}")
    # logger.info(f"Value of first fast packets variable: {shared_variables.first_fast_packets}")

    if audio_format == "ulaw":
        for i in range(length // block_size):

            if shared_variables.modbus_running == True:
                return 1

            # elapsed_time = time.perf_counter() - self._start_time  // i
            shared_variables.pmaster.audio_socket.sendto(
                audioop.lin2ulaw(audio_bin_buff[i * block_size: (i + 1) * block_size], 2),
                (
                    shared_variables.pmaster.page_to_address,
                    shared_variables.pmaster.page_to_port,
                ),
            )
            count = count + block_size

            if shared_variables.first_fast_packets < constants.PACKETS_NUMBER:
                time.sleep(0.002)
                shared_variables.first_fast_packets += 1
            else:
                time.sleep(delay)

        if leftover:
            shared_variables.pmaster.audio_socket.sendto(
                audioop.lin2ulaw(audio_bin_buff[length - leftover:], 2),
                (
                    shared_variables.pmaster.page_to_address,
                    shared_variables.pmaster.page_to_port,
                ),
            )
            count = count + leftover
        logger.info(f"Sent this many bytes: {count/2}, out of {length/2}")

    elif audio_format == "alaw":
        for i in range(length // block_size):

            if shared_variables.modbus_running == True:
                return 1

            shared_variables.pmaster.audio_socket.sendto(
                audioop.lin2alaw(audio_bin_buff[i * block_size: (i + 1) * block_size], 2),
                (
                    shared_variables.pmaster.page_to_address,
                    shared_variables.pmaster.page_to_port,
                ),
            )
            count = count + block_size
            time.sleep(delay)

        if leftover:
            shared_variables.pmaster.audio_socket.sendto(
                audioop.lin2alaw(audio_bin_buff[length - leftover:], 2),
                (
                    shared_variables.pmaster.page_to_address,
                    shared_variables.pmaster.page_to_port,
                ),
            )
            count = count + leftover
        logger.info(f"Sent this many bytes: {count}, out of {len(audio_bin_buff)}")
    else:
        msg = f"Audio format not recognized : {audio_format}"
        logger.error(msg)
        return -1
    return 0


def extract_token_and_audio(message: bytes) -> Tuple[str, bytes]:
    """
    Extracts the token and audio packet.
    The whole array is assumed to be 16 bit Int array. The token is encoded to its corresponding ASCII code.
    """

    try:
        token = "".join(
            [
                chr(
                    int.from_bytes(
                        message[2 * i: 2 * i + 2], "little", signed=True
                    )
                )
                for i in range(shared_variables.user_token_length)
            ]
        )
        # logger.info(f"The token in audio message is {token}")
    except Exception as e:
        logger.warning(f"Unable to extract the token. Error: {e}")
        token = "-1"
    audio = message[shared_variables.user_token_length*2:]
    # logger.info("Token and audio extracted")
    return token, audio





