import time

import threading
from streamer.RtpStreamer import *

from utils import get_logger, load_alsa_settings
import constants


class RtpProcessor:
    def __init__(self):
        self.logger = get_logger(__name__)

        self.logger.info("initialize...")

        pcmcDev = "plug:analog_in"
        #pcmcDev = "plug:null"
        #pcmcDev = "plug:dsnoop"
        #pcmcDev = "plug:loopback_out"
        #pcmcDev = "plug:loopback_in"

        #url = "rtp://" + ip + ":" + str(port)
        #print(f"url: {url}")
        
        self.rtpStreamer = RtpStreamer(pcmcDev, "", "")

        self.th = threading.Thread(target=self.run, args=(), daemon=True)
        self.th.start()

    def run(self):        
        while True:
            time.sleep(1)    

    def start_stream(self, ip, port, audioProfile):
        self.rtpStreamer.url = "rtp://" + ip + ":" + str(port)
        self.rtpStreamer.audioProfile = audioProfile
        self.rtpStreamer.loadProfileParams()

        self.logger.info(f"startStreamer with url: {self.rtpStreamer.url} format: {self.rtpStreamer.audioProfile}")
        self.rtpStreamer.startStreamer()
    
    def stop_stream(self):
        self.logger.info("stopStreamer")
        self.rtpStreamer.stopStreamer()


if __name__ == "__main__":
    print("start program")
    rtp = RtpProcessor()
    rtp.start_stream("192.168.20.180", 1234, "PCM16BE")
    count = 0
    while count<59:
        count+=1
        print(f"count {count}")
        time.sleep(1)
        