import logging
import time
import baco
from barix.media.BacoPlayer import BacoPlayer

logger = logging.getLogger('ipspeaker')

class RtpOutPlayer:
    def __init__(self, url, pcmpDev, playbackMode):
        self.url = url
        self.pcmpDev = pcmpDev
        self.mode = playbackMode
        self.player = None

    def startPlayer(self):
        if self.mode == 'regular':
            logger.info("Create RTP Regular Mode player ")
            self.player = baco.SimplePlayer(self.url, self.pcmpDev, 44100, baco.CONSTDELAY)
            self.player.setInputFifoDuration(0)
            self.player.setOutputFifoDuration(5000)
            self.player.setReadyThreshold(4500)
            self.player.setMaxDelta(30)
            logger.info(f"Start rtp player: url: {self.url}, audio dev: {self.pcmpDev}")
            self.player.connect()
        elif self.mode == "low_latency":
            logger.info("Create RTP Low Latency Mode player ")
            self.player = BacoPlayer(self.url, self.pcmpDev, 44100)
            self.player.start()
            time.sleep(1)
            self.player.connectAudio()
        else:
            logger.error("RTP Playback mode ERROR!")

    def stopPlayer(self):
        if self.player is not None:
            logger.info("Stop player")
            self.player.disconnect()