import threading
import time

from utils import get_logger

class WatchDog:
    def __init__(self):
        self.logger = get_logger("WatchDog")
        self.logger.info("Debug initialize...")

        self.counter = 0
        self.timeout = 5
        self.callback = None
        self.message = None
        self.running = False
        
        self.th = threading.Thread(target=self.run, args=(), daemon=True)
        self.th.setName("WatchDog")
        self.th.start()

    def config(self, timeout=10, callback=None, message=None):
        self.timeout = timeout
        self.callback = callback
        self.message = message

    def reset(self):
        self.counter = 0

    def start(self):
        self.logger.debug("start watchDog")
        self.counter = 0
        self.running = True
    
    def stop(self):
        self.logger.debug("stop watchDog")
        self.counter = 0
        self.running = False

    def run(self):        
        while True:
            if self.running == True:
                self.counter+=1
                print(f"watchdog counter {self.counter}")
                if self.counter > self.timeout and self.callback != None:
                    print("call watchdog")
                    self.logger.info("WatchDog Timeout")
                    self.callback(self.message)

            for i in range(0,100):
                time.sleep(0.01)

