#!/bin/bash
#
# The purpose of this scrip is to used to develop stage.
#

echo -e "\n  \033[1;30;47m BARIX \033[00m  Run docker container for Angular compile environment${1}\n"

PROJECT_NAME="$(jq -j .name ../package.json)-build-env"
PROJECT_VERSION=$(jq -j .version ../package.json)
HOST_PORT=4200
HOST_PROJECT_DIR=$(pwd)/..
UNAME=$(echo $USER)

#--------------------------------------------------
# Colors settings
C_RESET="\e[00m"            # Reset colors
C_HIGHLIGHT="\e[0;37;1m"    # Foreground highlight
C_YELLOW="\e[0;33;1m"       # Foreground yellow
C_GREEN="\e[0;32;1m"        # Foreground green
C_ERROR="\e[0;31;1m"        # Foreground error
#--------------------------------------------------

function testExitStatus {
  # $1 - Exit status
  # $2 - Error message
  if [ $1 -ne 0 ]; then
    echo -ne "\n${C_ERROR}ERROR${C_HIGHLIGHT} - ${2}${C_RESET}\n\n"
    exit -1
  fi
}

echo -ne "${C_GREEN}  ${PROJECT_NAME}:${PROJECT_VERSION}${C_RESET}\n\n"

# Stop and remove possible running docker container
docker stop ${PROJECT_NAME} -t 8 > /dev/null 2>&1
docker rm ${PROJECT_NAME} > /dev/null 2>&1

# Start docker image and mount to host workdir file system
docker run --name ${PROJECT_NAME} -it \
  -h node-build-env \
  -p ${HOST_PORT}:4200 \
  -v ${HOST_PROJECT_DIR}:/home/${UNAME}/project \
  barix/${PROJECT_NAME}:${PROJECT_VERSION} /bin/bash
