import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';
import { MainPageComponent } from './paging/main-page/main-page.component';
import { MainHeaderComponent } from './paging/main-header/main-header.component';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { MatIconModule } from '@angular/material/icon';
import { MainBoardComponent } from './paging/main-board/main-board.component';
import { MainBottomComponent } from './paging/main-bottom/main-bottom.component';
import { AppButtonComponent } from './paging/app-button/app-button.component';
import {MatButtonModule} from "@angular/material/button";
import { SettingsPageComponent } from './paging/settings-page/settings-page.component';
import { MenuHeaderComponent } from './paging/menu-header/menu-header.component';
import { MenuBodyOptionsComponent } from './paging/menu-body-options/menu-body-options.component';
import {MatSlideToggleModule} from "@angular/material/slide-toggle";
import { PagingGroupListComponent } from './paging/paging-group-list/paging-group-list.component';
import {MatListModule} from "@angular/material/list";
import { FooterComponent } from './paging/footer/footer.component';
import { GroupSettingsPageComponent } from './paging/group-settings-page/group-settings-page.component';
import { PagingMenuComponent } from './paging/group-menu/paging-menu.component';
import {FormsModule, ReactiveFormsModule} from "@angular/forms";
import {Ng2SearchPipeModule} from "ng2-search-filter";
import {MatInputModule} from "@angular/material/input";
import { PagingGroupsComponent } from './paging/paging-group-page/paging-groups.component';
import { DeviceMessagePageComponent } from './paging/device-message-page/device-message-page.component';
import { DeviceMessageBodyComponent } from './paging/device-message-body/device-message-body.component';
import {MatTableModule} from "@angular/material/table";
import {HTTP_INTERCEPTORS, HttpClientModule} from "@angular/common/http";
import { RecordingButtonComponent } from './paging/recording-button/recording-button.component';
import { MenuOptionSpanComponent } from './paging/menu-option-span/menu-option-span.component';
import {MatOptionModule, MatRippleModule} from "@angular/material/core";
import {MatCheckboxModule} from "@angular/material/checkbox";
import {SettingsComponent} from "./settings/settings.component";
import {SystemStatusComponent} from "./system-status/system-status.component";
import {LogsComponent} from "./logs/logs.component";
import {DefaultsComponent} from "./defaults/defaults.component";
import {UpdateTabComponent} from "./update-tab/update-tab.component";
import {RebootComponent} from "./reboot/reboot.component";
import {LoginComponent} from "./login/login.component";
import {MainComponent} from "./main/main.component";
import {AdditionalCertificatesService} from "./services/additional.certificates.service";
import {AdditionalCertificatesComponent} from "./additional-certificates/additional.certificates.component";
import {UploadFilesModalComponent} from "./upload-files-modal/upload-files-modal.component";
import {FirmwareUpdaterComponent} from "./firmware-updater/firmware-updater.component";
import {DeviceLicenseComponent} from "./device-license/device-license.component";
import {GreedyNavComponent} from "./greedy-nav/greedy-nav.component";
import {OpenSourceLicensesComponent} from "./open-source-licenses/open-source-licenses.component";
import {CanDeactivateDeviceMessageGuard, CanDeactivateGuard} from "./can-deactivate/can-deactivate.guard";
import {ExtendSessionTimeoutInterceptor} from "./httpInterceptors/extendedSessionTimeoutInterceptor";
import {FwUpdaterStatusModalComponent} from "./fw-updater-status-modal/fw-updater-status-modal.component";
import {MatProgressBarModule} from "@angular/material/progress-bar";
import {MatSidenavModule} from "@angular/material/sidenav";
import {MatToolbarModule} from "@angular/material/toolbar";
import {MatMenuModule} from "@angular/material/menu";
import {DisableAutocompleteHackComponent} from "./base-components/disable-autocomplete-hack/disable-autocomplete-hack.component";
import {MuteButtonComponent} from "./base-components/mute-button/mute-button.component";
import {MatSliderModule} from "@angular/material/slider";
import {CollapConfigPanelModule} from "./base-components/collap-config-panel/collap-config-panel.module";
import {MatDialogModule} from "@angular/material/dialog";
import {MatSelectModule} from "@angular/material/select";
import {ToastrModule} from 'ngx-toastr';
import {LoadingWidgetModule} from "./base-components/loading-widget/loading-widget.module";
import {PagingLoadingWidgetModule} from "./paging/loading-widget/loading-widget.module";
import { PagingSettingsTabComponent } from './paging-settings-tab/paging-settings-tab.component';
import { UsersManagementTabComponent } from './users-management-tab/users-management-tab.component';
import {MatPaginatorModule} from "@angular/material/paginator";
import { NewOrEditUserComponent } from './new-or-edit-user/new-or-edit-user.component';
import { UserDetailsModalComponent } from './user-details-modal/user-details-modal.component';
import {QRCodeModule} from "angularx-qrcode";
import { GroupsTabComponent } from './groups-tab/groups-tab.component';
import { NewOrEditGroupModalComponent } from './new-or-edit-group-modal/new-or-edit-group-modal.component';
import { AudioFilesTabComponent } from './audio-files-tab/audio-files-tab.component';
import { NewAudioFileModalComponent } from './new-audio-file-modal/new-audio-file-modal.component';
import {MatStepperModule} from "@angular/material/stepper";
import { EditAudioFileModalComponent } from './edit-audio-file-modal/edit-audio-file-modal.component';
import {MatTabsModule} from "@angular/material/tabs";
import {MatSortModule} from "@angular/material/sort";
import { SelectFromListComponent } from './select-from-list/select-from-list.component';
import { DeviceMessageCustomValidatorDirective } from './audio-files-tab/device-message-custom-validator.directive';




@NgModule({
  declarations: [
    AppComponent,
    MainPageComponent,
    MainHeaderComponent,
    MainBoardComponent,
    MainBottomComponent,
    AppButtonComponent,
    SettingsPageComponent,
    MenuHeaderComponent,
    MenuBodyOptionsComponent,
    PagingGroupListComponent,
    FooterComponent,
    GroupSettingsPageComponent,
    PagingMenuComponent,
    PagingGroupsComponent,
    DeviceMessagePageComponent,
    DeviceMessageBodyComponent,
    RecordingButtonComponent,
    MenuOptionSpanComponent,
      SettingsComponent,
      SystemStatusComponent,
      LogsComponent,
      DefaultsComponent,
      UpdateTabComponent,
      RebootComponent,
      LoginComponent,
      MainComponent,
      AdditionalCertificatesComponent,
      UploadFilesModalComponent,
      FirmwareUpdaterComponent,
      DeviceLicenseComponent,
      GreedyNavComponent,
      OpenSourceLicensesComponent,
      FwUpdaterStatusModalComponent,
      DisableAutocompleteHackComponent,
      MuteButtonComponent,
      PagingSettingsTabComponent,
      UsersManagementTabComponent,
      NewOrEditUserComponent,
      UserDetailsModalComponent,
      GroupsTabComponent,
      NewOrEditGroupModalComponent,
      AudioFilesTabComponent,
      NewAudioFileModalComponent,
      EditAudioFileModalComponent,
      SelectFromListComponent,
      DeviceMessageCustomValidatorDirective,

  ],
    imports: [
        BrowserModule,
        AppRoutingModule,
        MatIconModule,
        HttpClientModule,
        BrowserAnimationsModule,
        MatButtonModule,
        MatSlideToggleModule,
        MatListModule,
        FormsModule,
        ReactiveFormsModule,
        Ng2SearchPipeModule,
        MatInputModule,
        MatTableModule,
        MatRippleModule,
        LoadingWidgetModule,
        PagingLoadingWidgetModule,
        MatCheckboxModule,
        ToastrModule.forRoot(), // ToastrModule added
        MatProgressBarModule,
        MatSidenavModule,
        MatToolbarModule,
        MatButtonModule,
        MatMenuModule,
        MatOptionModule,
        MatSliderModule,
        MatDialogModule,
        MatSelectModule,
        CollapConfigPanelModule,
        MatPaginatorModule,
        QRCodeModule,
        MatStepperModule,
        MatTabsModule,
        MatSortModule
    ],
  providers: [
      CanDeactivateGuard,
      CanDeactivateDeviceMessageGuard,
      { provide: HTTP_INTERCEPTORS, useClass: ExtendSessionTimeoutInterceptor, multi: true },
  ],
  bootstrap: [AppComponent]
})
export class AppModule { }
