import { Directive } from '@angular/core';
import {AbstractControl, ValidationErrors, ValidatorFn} from "@angular/forms";

@Directive({
  selector: '[appModbusIndexCustomValidator]'
})
export class DeviceMessageCustomValidatorDirective {

  constructor() { }

}

export function ModbusIndexCustomValidator(previous_modbus_idx, modbus_idx_list): ValidatorFn {
    return (control: AbstractControl): ValidationErrors | null => {
        if (control.value !== null) {
            if (previous_modbus_idx !== control.value){
                if (control.value < 1 || control.value > 999) {
                    return {idxOutOfRange: true};
                } else {
                    for (const modbus_idx of modbus_idx_list) {
                        if (modbus_idx === control.value) {
                            return {duplicatedIdx: true};
                        }
                    }
                }
            }
        }
        return null;
    };
}

export function ButtonNameCustomValidator(previous_btn_name, btn_name_list): ValidatorFn {
    return (control: AbstractControl): ValidationErrors | null => {
        if (previous_btn_name !== control.value){
            for (const btn_name of btn_name_list) {
                if (btn_name === control.value) {
                    console.log("ButtonNameCustomValidator duplicated")
                    return {duplicatedBtnName: true};
                }
            }
        }
        console.log("ButtonNameCustomValidator value didn't change");
        return null;
    };
}
