import {
    Component,
    ContentChildren,
    Directive,
    Input,
    OnInit,
    QueryList
} from '@angular/core';
import {MatExpansionModule} from '@angular/material/expansion';

@Component({
    selector: 'brx-collap-config-panel',
    templateUrl: './collap-config-panel.component.html',
    styleUrls: [ './collap-config-panel.component.css' ]
})

export class CollapConfigPanelComponent implements OnInit {
    @ContentChildren(CollapConfigPanelComponent) contentChildren!: QueryList<CollapConfigPanelComponent>;
    @ContentChildren(CollapConfigPanelComponent, {descendants: true}) arbitraryNestedPanes!: QueryList<CollapConfigPanelComponent>;
    @Input() headerText: string = 'This is the header text';
    @Input() expanded: boolean = false;
    @Input() headerColor: string = 'unset';
    @Input() headerFontSize: string = 'unset';

    isOpen: boolean = false;

    ngOnInit(): void {
    }

    isPanelOpen(): boolean {
        return this.isOpen;
    }

}
