import {Component, Input} from '@angular/core';


@Component({
    selector: 'brx-loading-widget',
    templateUrl: './loading-widget.component.html',
    styleUrls: ['./loading-widget.component.css']
})


export class LoadingWidgetComponent {
    @Input() show: boolean = false;
    @Input() text: string | string[] | undefined = undefined;
    @Input() marginTop: string = "0";
    @Input() fontSize: string = "1em";


    getMessages(): string[] {
        if (this.text) {
            if (typeof this.text === "string") {
                return [this.text];
            } else {
                return this.text.map((msg) => msg);
            }
        }
        return [];
    }

}
