import { Component, OnInit, Input, ViewEncapsulation, forwardRef } from '@angular/core';


import {
  AbstractControl,
  ControlContainer,
  ControlValueAccessor,
  FormControl,
  NG_VALIDATORS,
  NG_VALUE_ACCESSOR,
  ValidationErrors
} from "@angular/forms";


@Component({
  selector: 'brx-slider-on-off',
  templateUrl: './slider-on-off.component.html',
  styleUrls: ['./slider-on-off.component.css'],
  providers: [
    {
      provide: NG_VALUE_ACCESSOR,
      multi: true,
      useExisting: SliderOnOffComponent
    },
    {
      provide: NG_VALIDATORS,
      multi: true,
      useExisting: SliderOnOffComponent
    }
  ]
})


export class SliderOnOffComponent implements ControlValueAccessor {
  @Input() formControlName:string;

  control:AbstractControl;
  // value: boolean = false;


  constructor(private controlContainer: ControlContainer) {
  }

  onChange = (event) => {
  };

  onTouched = () => {
  };

  touched = false;
  disabled = false;

  ngOnInit(): void {
    // console.log("### ngOnInit MUTED", this.muted, typeof this.muted);
    if(this.controlContainer && this.formControlName){
      this.control = this.controlContainer.control.get(this.formControlName);
    }
  }


  ngOnChanges(): void {
    // Update display value if input value change
    // Will not fire any event
  }


  registerOnChange(fn: any): void {
    this.onChange = fn;
  }


  registerOnTouched(fn: any): void {
    this.onTouched = fn;
  }


  writeValue(newValue: boolean): void {
    // this.value = newValue === true;
  }


  markAsTouched() {
    if (!this.touched) {
      this.onTouched();
      this.touched = true;
    }
  }


  setDisabledState(disabled: boolean) {
    this.disabled = disabled;
  }


  validate(control: AbstractControl): ValidationErrors | null {
    return {};
  }

}
