import {Injectable} from '@angular/core';
import {CanDeactivate} from '@angular/router';
import {ComponentCanDeactivate} from "./component-can-deactivate";


@Injectable({
    providedIn: 'root'
})


export class CanDeactivateGuard implements CanDeactivate<ComponentCanDeactivate> {
    canDeactivate(component: ComponentCanDeactivate): boolean {
        if (component && !component.canDeactivate()) {
            return confirm("You have unsaved changes! If you leave, your changes will be lost.");
        }
        return true;
    }
}

export class CanDeactivateDeviceMessageGuard implements CanDeactivate<ComponentCanDeactivate> {
    canDeactivate(component: ComponentCanDeactivate): boolean {
        if (component && !component.canDeactivate()) {
            return confirm("If you leave, your will not be able to stop playing the device message before it finishes. Are you sure you want to leave?");
        }
        return true;
    }
}
