import { Component, OnInit } from '@angular/core';
import {Router} from "@angular/router";
import {FormCanDeactivate} from "../../can-deactivate/form-can-deactivate";


@Component({
  selector: 'app-device-message-page',
  templateUrl: './device-message-page.component.html',
  styleUrls: ['./device-message-page.component.css']
})
export class DeviceMessagePageComponent extends FormCanDeactivate implements OnInit {

    playingState : boolean;

  constructor(private router: Router) {
      super();
  }

    canDeactivateComponent() {
        return !this.playingState;
    };

  ngOnInit(): void {
  }


  backToMenu(){
    this.router.navigate(['/paging/menu'], { queryParamsHandling: "merge" });
  }

  newPlayingState(state: boolean) {
      this.playingState = state;
  }
}
