import {Component, EventEmitter, OnInit, Output} from '@angular/core';
import {ActivatedRoute, Router} from "@angular/router";
import {UserService} from "../services/user.service";

@Component({
  selector: 'app-main-header',
  templateUrl: './main-header.component.html',
  styleUrls: ['./main-header.component.css']
})
export class MainHeaderComponent implements OnInit {

  username;
  token
  constructor(private router: Router,
              private route: ActivatedRoute,
              private userService: UserService) { }

  async ngOnInit(){
    this.token = this.route.snapshot.queryParamMap.get('token')
    this.userService.getUserNameByToken(this.token).subscribe((data)=>{
      switch (data.status) {
        case 200:
          this.username = data.body.name;
          break;
        default:
          alert("Something went wrong!");
          break;
      }
    })

  }


  goTo(routePath:string){
    switch (routePath){
      case "menu":
        this.router.navigate(["menu"], { queryParamsHandling: "merge" , relativeTo: this.route });
        break;
      case "settings":
        this.router.navigate(['settings'], { queryParamsHandling: "merge" , relativeTo: this.route  })
        break;
    }
  }
}
