import {Injectable} from '@angular/core';
import {HttpClient, HttpHeaders} from "@angular/common/http";
import ServiceUtils from "../../services/service.utils";
import {catchError, Observable} from "rxjs";
import {environment} from "../../../environments/environment";

@Injectable({
    providedIn: 'root'
})
export class GroupsService {

    constructor(private http: HttpClient) {
    }

    private readonly PAGING_ENDPOINT = environment.pagingEndpoint;
    // private readonly GROUPS_ENDPOINT = environment.groupsEndpoint;

    buildHttpOptions(): any {
        return {
            observe: "response" as "response"
        }
    }

    getAllGroups(token: string): Observable<any> {
        const url = this.PAGING_ENDPOINT + '/groups?token=' + token;
        return this.http.get<any>(url, this.buildHttpOptions()).pipe(
            catchError(err1 => ServiceUtils.handleError(err1))
        );
    }

}
