import {Injectable} from '@angular/core';
import {HttpClient, HttpHeaders} from "@angular/common/http";
import {catchError, Observable} from "rxjs";
import {environment} from "../../../environments/environment";
import ServiceUtils from "../../services/service.utils";

@Injectable({
    providedIn: 'root'
})
export class UserService {

    constructor(private http: HttpClient) {
    }

    private readonly PAGING_ENDPOINT = environment.pagingEndpoint;

    getUserNameByToken(token): Observable<any> {
        const url = this.PAGING_ENDPOINT+ '/users/' + token + '/name';
        return this.http.get<any>(url, {observe: "response" as "response"}).pipe(
            catchError(err1 => ServiceUtils.handleError(err1))
        );
    }
}
