import { Injectable } from '@angular/core';
import {Observable, of, throwError} from 'rxjs';
import {catchError, switchMap} from 'rxjs/operators';
import {environment} from '../../environments/environment';
import {HttpClient, HttpErrorResponse, HttpEvent, HttpHeaders, HttpProgressEvent, HttpRequest} from '@angular/common/http';

const FILE_UPLOAD_ENDPOINT = environment.fwUpdateEndpoint;

@Injectable({
  providedIn: 'root'
})
export class FirmwareUploadService {

  constructor(private httpClient: HttpClient) { }

  private httpOptions = {
    observe: 'response' as 'response'
  };

  upload(file):Observable<any> {

    //console.log(file);

    // Create form data
    let formData = new FormData();

    formData.append('fwImage', file, file.name);

    //console.log(formData.getAll('certificate'));

    // Make http post request over api
    // with formData as req
    /*return this.httpClient.post<any>(FILE_UPLOAD_ENDPOINT,formData, {
      reportProgress: true,
      observe: 'events',
      responseType: 'json',
      //rejectUnauthorized: false,
      /*headers: new HttpHeaders({
        'rejectUnauthorized': 'false'
      })*/
    /*}).pipe(
        catchError(err1 => this.handleError(err1))
    );*/

    const req = new HttpRequest('POST', FILE_UPLOAD_ENDPOINT, formData, {
      reportProgress: true,
      responseType: 'json',
      /*headers: new HttpHeaders({
        'rejectUnauthorized': 'false'
      })*/
    });

    return this.httpClient.request(req);
  }

  getUpdateStatus(): Observable<any> {
    //console.log('Check Update Status GET "%s"', FILE_UPLOAD_ENDPOINT);
    return this.httpClient.get<any>(FILE_UPLOAD_ENDPOINT, this.httpOptions).pipe(
        catchError(err1 => this.handleError(err1))
    );
  }

  private handleError(error: HttpErrorResponse) {
    if (error.error instanceof ErrorEvent) {
      // A client-side or network error occurred. Handle it accordingly.
      console.error('An error occurred:', error.error.message);
    } else {
      // The backend returned an unsuccessful response code.
      // The response body may contain clues as to what went wrong.
      console.error(
          `Backend returned code ${error.status}, ` +
          `body was: ${error.error}`);
    }
    // Return an observable with a user-facing error message.
    //return throwError('Something bad happened; please try again later.');
    return of(error); //returns HttpErrorResponse with status 0
  }
}
