import {environment} from "../../environments/environment";
import {HttpErrorResponse} from "@angular/common/http";
import {of} from "rxjs";


class ServiceUtils {

    public static handleError(error: HttpErrorResponse) {

        if (error.error instanceof ErrorEvent) {
            // A client-side or network error occurred. Handle it accordingly.
            console.error('An error occurred:', error.message);
        } else {
            // The backend returned an unsuccessful response code.
            // The response body may contain clues as to what went wrong.
            console.error(
                `Backend returned code ${error.status}, ` +
                `body was: ${error.message}`);
        }
        // Return an observable with a user-facing error message.
        //return throwError('Something bad happened; please try again later.');
        return of(error); //returns HttpErrorResponse with status 0
    }
}


export default ServiceUtils;
