import { Injectable } from '@angular/core';
import {ToastrService} from "ngx-toastr";

@Injectable({
  providedIn: 'root'
})
export class ToastMessageService {

  DEFAULT_TOASTR_TIMEOUT = 10000; //10s

  constructor(  private toastr: ToastrService ) { }

  showWarningMessage(message: string, disableTimeout:boolean=false, timeout=this.DEFAULT_TOASTR_TIMEOUT) {
    // if (disableTimeout === true){
    //   this.toastr.show(message, '', {closeButton : true, disableTimeOut: true, toastClass: 'my-toast-warning'});
    // } else {
    //   this.toastr.show(message, '', {closeButton : true, timeOut: timeout, toastClass: 'my-toast-warning'});
    // }
      if (disableTimeout === true){
          this.toastr.warning(message, '', {closeButton : true, disableTimeOut: true});
      } else {
          this.toastr.warning(message, '', {closeButton : true, timeOut: timeout});
      }
  }

  showErrorMessage(message: string, disableTimeout:boolean=false, timeout=this.DEFAULT_TOASTR_TIMEOUT) {
    // if (disableTimeout === true){
    //   this.toastr.show(message, '', {closeButton : true, disableTimeOut: true, toastClass: 'my-toast-error'});
    // } else {
    //   this.toastr.show(message, '', {closeButton : true, timeOut: timeout, toastClass: 'my-toast-error'});
    // }
      if (disableTimeout === true){
          this.toastr.error(message, '', {closeButton : true, disableTimeOut: true});
      } else {
          this.toastr.error(message, '', {closeButton : true, timeOut: timeout});
      }
  }

  showSuccessMessage(message: string, disableTimeout:boolean=false, timeout=this.DEFAULT_TOASTR_TIMEOUT) {
    // if (disableTimeout === true){
    //   this.toastr.show(message, '', {closeButton : true, disableTimeOut: true, toastClass: 'my-toast-success'});
    // } else {
    //   this.toastr.show(message, '', {closeButton : true, timeOut: timeout, toastClass: 'my-toast-success'});
    // }
      if (disableTimeout === true){
          this.toastr.success(message, '', {closeButton : true, disableTimeOut: true});
      } else {
          this.toastr.success(message, '', {closeButton : true, timeOut: timeout});
      }
  }

  clearToastMessages(){
    //let existingToasts = document.getElementById("toast-container");
    //if (existingToasts){
    //  this.toastr.clear();
    //}
    this.toastr.clear();
  }
}
