import {Component, ElementRef, Inject, OnInit, ViewChild} from '@angular/core';
import {MAT_DIALOG_DATA} from "@angular/material/dialog";
import jsPDF from 'jspdf';
import html2canvas from "html2canvas";

@Component({
  selector: 'app-user-details-modal',
  templateUrl: './user-details-modal.component.html',
  styleUrls: ['./user-details-modal.component.css']
})
export class UserDetailsModalComponent implements OnInit {

    @ViewChild('pdfContent') pdfContent: ElementRef;

  constructor(@Inject(MAT_DIALOG_DATA) public data: UserDetails) { }

  ngOnInit(): void {
  }

  async downloadAsPdf() {
      const filename = "User_" + this.data.name + "_info.pdf";
      const doc = new jsPDF();
      await html2canvas(this.pdfContent.nativeElement).then(canvas => {
          const imgWidth = 208; // your own stuff to calc the format you want
          const imgHeight = canvas.height * imgWidth / canvas.width; // your own stuff to calc the format you want
          const contentDataURL = canvas.toDataURL('image/png');
          doc.addImage(contentDataURL, 'PNG', 0, 0, imgWidth, imgHeight);
          doc.save(filename);
      });
  }
}

export interface UserDetails {
    id: string;
    name: string;
    email: string;
    access_url: string;
}
